"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPermission = void 0;
var solid_js_1 = require("solid-js");
/**
 * Querying the permission API
 *
 * @param name permission name (e.g. "microphone") or a PermissionDescriptor object (`{ name: ... }`)
 * @returns "unknown" | "pending" | "granted" | "rejected"
 */
var createPermission = function (name) {
    var _a = (0, solid_js_1.createSignal)("unknown"), permission = _a[0], setPermission = _a[1];
    navigator.permissions.query(typeof name === "string" ? { name: name } : name).then(function (status) {
        setPermission(status.state);
        var listener = function () { return setPermission(status.state); };
        status.addEventListener("change", listener);
        (0, solid_js_1.onCleanup)(function () {
            status.removeEventListener("change", listener);
        });
    });
    return permission;
};
exports.createPermission = createPermission;
